import keras
from hw1_utils import load_data
# >> You are free to add other packages from keras <<

mnist_path = 'mnist.pkl.gz'


def build_model(input_dim=784, num_class=10):
    """build_model Build a Keras model of logistic regression

    Keyword Arguments:
        input_dim {int} -- The number of dimensions for the input data
            (default: {784})
        num_class {int} -- The number of classes (default: {10})

    Returns:
        {keras.models.Model} -- Your logistic regression model. It is a
            keras.model.Model object created by either a sequential way or a
            functional way.

    """
    model = None

    # >> Your code starts here. <<

    # >> Your code ends here. <<

    return model


def run_keras(epochs=10, learning_rate=1.0, batch_size=64):
    """ Build model, train it, and test it. Return the test accuracy.

    Keyword Arguments:
       epochs {int} -- The number of epochs for training.
       learning_rate {float} -- The learning rate for each epoch
       batch_size {int} -- The number of samples in each mini-batch

    Returns:
       {float} -- Model's accuracy on test data.

    """

    train_X, train_y, val_X, val_y, test_X, test_y = load_data(mnist_path)

    input_dim = train_X.shape[1]
    num_class = len(set(train_y))

    test_accuracy = None

    # >> Your code starts here. <<

    # >> Your code ends here. <<

    print('Test Accuracy: {}'.format(test_accuracy))

    return test_accuracy


if __name__ == '__main__':
    run_keras()
